<?php

namespace STM\Competition;

use \GetterOfTestingInstances;
use STM\StmFactory;

/**
 * Test class for Competitions.
 * Generated by PHPUnit on 2012-02-06 at 20:19:46.
 * @group competition
 */
class CompetitionsTest extends \PHPUnit_Framework_TestCase {

    protected function setUp() {}
    
    public function testfindById() {
        parent::assertFalse(StmFactory::find()->Competition->findById(null));
        
        parent::assertFalse(StmFactory::find()->Competition->findById(-1));

        $playoff = GetterOfTestingInstances::getPlayoff();
        if ($playoff) {
            parent::assertInstanceOf('\STM\Competition\Playoff\Playoff', StmFactory::find()->Competition->findById($playoff->getId()));
        }
        
        $season = GetterOfTestingInstances::get_season();
        if ($season) {
            parent::assertInstanceOf('\STM\Competition\Season\Season', StmFactory::find()->Competition->findById($season->getId()));
        }
        
        $competition = GetterOfTestingInstances::get_competition();
        if ($competition) {
            parent::assertInstanceOf('\STM\Competition\Competition', StmFactory::find()->Competition->findById($competition->getId()));
        }
    }

    public function testFind() {
        parent::assertTrue(is_array(StmFactory::find()->Competition->find(new CompetitionSelection())));
    }

    public function testExists_competition() {
        parent::assertFalse(Competition::exists(null));
        parent::assertFalse(Competition::exists(1));
        parent::assertFalse(Competition::exists(array()));
        
        $cs = new CompetitionSelection();
        foreach (StmFactory::find()->Competition->find($cs) as $competition) {
            $name = $competition->__toString();
            $this->assertFalse(Competition::exists($competition));
            $this->assertTrue(Competition::exists($name));
            $this->assertTrue(Competition::exists(mb_strtolower($name, 'UTF-8')));
            $this->assertTrue(Competition::exists(mb_strtoupper($name, 'UTF-8')));
            // no trim, only string
            $this->assertFalse(Competition::exists('      ' . $name));
            $this->assertFalse(Competition::exists('      ' . $name . '        '));
        }
    }

}

?>
